﻿using Oracle.ManagedDataAccess.Client;
using SYS_Core.aControl;
using System;
using System.Net;
using System.Net.Http;
using System.Web.Http.Controllers;
using System.Web.Http.Filters;

namespace SYSCore.Attributes
{
    public class RunBatchGuardAttribute : ActionFilterAttribute
    {
        private DBOracle oOracledb = new DBOracle();

        public override void OnActionExecuting(HttpActionContext actionContext)
        {
            HttpRequestMessage request = actionContext.Request;
            string ErrorMessage;
            if (!CheckBatchRunning(out ErrorMessage))
            {
                actionContext.Response = new System.Net.Http.HttpResponseMessage()
                {
                    Content = new StringContent(String.Concat("[System]", ErrorMessage)),
                    StatusCode = HttpStatusCode.Forbidden
                };
            }

            base.OnActionExecuting(actionContext);
        }

        private bool CheckBatchRunning(out string ErrorMessage)
        {
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_CHECK_BATCH_RO_RUNNING";
                cmd = oOracledb.SqlQueryReturnValue(cmd);

                ErrorMessage = "";

                return true;

            }
            catch (OracleException ex)
            {
                if(ex.Number == 20001)
                {
                    ErrorMessage = oOracledb.GetErrorMessage(ex);

                    return false;
                }

                throw new Exception("Unknown error");
            }
            catch (Exception ex)
            {
                ErrorMessage = ex.Message;
                return false;
            }
        }
    }
}