﻿using SYS_Core.aControl;
using System;
using System.Web.Http;
using System.Web.Http.Cors;
using Oracle.ManagedDataAccess.Client;
using System.Data;
using System.Net.Http;
using System.Net;
using SYS_Core.aBiz;
using System.Threading.Tasks;
using System.Configuration;
using SYS_Core.Controllers;
using System.Collections;
using System.Web;
using System.IO;
using System.Linq;
using SYSCore.Attributes;
using Newtonsoft.Json;
using System.Collections.Generic;
using System.Security.Claims;
using SYS_Core.Services;
using System.Data.SqlClient;
using SYSCore.ReportingService;
using System.Net.Http.Headers;
using SYSCore.aControl;

namespace SYSCore.Controllers
{
    [EnableCors("*", "*", "*")]
    [RoutePrefix("api/Report")]
    public class ReportController : ApiController
    {

        private DBManager odb = new DBManager();
        private String gSQL = "";
        private String mDBName = ConfigurationManager.AppSettings["SYSDBName"];

        private DBOracle oOracledb = new DBOracle();
        private DataService dataService = new DataService();
        public TokenService _tokenService = new TokenService();
        #region Report

        [HttpGet, Route("GetPOClass")]
        [ReportAuthorize]
        public HttpResponseMessage GetPOClass()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
          
            try
            {

                cmd.CommandText = "SP_NP_MT_PO_CLASS_LIST";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);

            }
            catch (Exception ex)
            {
                return Request.CreateResponse(HttpStatusCode.NoContent, dt);
            }

        }

        [HttpPost, Route("GetPONo")]
        [ReportAuthorize]
        public HttpResponseMessage GetPONo([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
           

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_MT_PO_NO_BYID";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PO_NO", OracleDbType.Varchar2).Value = param.PO_NO;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            return Request.CreateResponse(HttpStatusCode.OK, dt);
        }

        [HttpPost, Route("GetManualPart")]
        [ReportAuthorize]
        public HttpResponseMessage GetManualPart([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            //partno = ismoUtil.escapeCharacter(partno);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_PRINT_LABEL_MANUALPRINT";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 1000;
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            return Request.CreateResponse(HttpStatusCode.OK, dt);
        }

        [HttpGet, Route("GetIndentDetailPartNo/{partNo}")]
        [ReportAuthorize]
        public HttpResponseMessage GetIndentDetailPartNo(string partNo)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();

            //partNo = ismoUtil.escapeCharacter(partNo);

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_SNSQ088_OrderPartNo";
            cmd.Parameters.Add("p_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("p_PART_NO", OracleDbType.Varchar2).Value = partNo;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            return Request.CreateResponse(HttpStatusCode.OK, dt);
        }


        [HttpGet, Route("GetVendorCode/{vendorcode}")]
        [ReportAuthorize]
        public HttpResponseMessage GetVendorCode(string vendorcode)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            

            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "sp_NP_MT_VENDOR_CODE_ByID";
            cmd.Parameters.Add("p_VENDOR_CODE", OracleDbType.Varchar2).Value = vendorcode ;
            cmd.Parameters.Add("p_SHOW_RECORD", OracleDbType.Int16).Value = 100;
            cmd.Parameters.Add("c_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;

            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            return Request.CreateResponse(HttpStatusCode.OK, dt);
        }


        [HttpGet, Route("GetDataPrintLabel")]
        [ReportAuthorize]
        public HttpResponseMessage GetDataPrintLabel()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSQ088_PRN_RPT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetDataPrintLabel");
                return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
            }
        }

        [HttpGet, Route("GetDataPrintLabelManual")]
        [ReportAuthorize]
        public HttpResponseMessage GetDataPrintLabelManual()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNSQ088_PRN_RPT_NEW";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME); ;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetDataPrintLabelManual");
                return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
            }
        }

        [HttpGet, Route("GetVendor")]
        [ReportAuthorize]
        public HttpResponseMessage GetVendor()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_MT_VENDOR_CODE";
                //cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                //cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME); ;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetDataPrintLabel");
                return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
            }
        }


        [HttpPost, Route("GenReportByCriteria")]
        [ReportAuthorize]
        public HttpResponseMessage GenReportByCriteria([FromBody] dynamic SRM)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_GET_PO_LABEL";
            try
            {
                
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = SRM.DATE_FROM == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.DATE_FROM);
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = SRM.DATE_TO == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.DATE_TO);
                cmd.Parameters.Add("P_FROM_PO_NO", OracleDbType.Varchar2).Value = SRM.FROM_PO == null ? (object)DBNull.Value : SRM.FROM_PO;
                cmd.Parameters.Add("P_TO_PO_NO", OracleDbType.Varchar2).Value = SRM.TO_PO == null ? (object)DBNull.Value : SRM.TO_PO; ;
                cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = SRM.PO_CLASS == null ? (object)DBNull.Value : SRM.PO_CLASS; ;
                cmd.Parameters.Add("P_FROM_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.FROM_VENDOR == null ? (object)DBNull.Value : SRM.FROM_VENDOR; ;
                cmd.Parameters.Add("P_TO_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.TO_VENDOR == null ? (object)DBNull.Value : SRM.TO_VENDOR; ;
                cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = SRM.VENDOR_TYPE == null ? (object)DBNull.Value : SRM.VENDOR_TYPE; ;
                cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = SRM.ORDER_PART_NO == null ? (object)DBNull.Value : SRM.ORDER_PART_NO; ;
                cmd.Parameters.Add("P_PRINT_STATUS", OracleDbType.Varchar2).Value = SRM.PRINT_STATUS == null ? (object)DBNull.Value : SRM.PRINT_STATUS; ;
                cmd.Parameters.Add("P_IC_INCHARGE", OracleDbType.Varchar2).Value = SRM.IC_INCHARGE == null ? (object)DBNull.Value : SRM.IC_INCHARGE; ;
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Request.CreateResponse(HttpStatusCode.OK, "DONE");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GenReportByCriteria");
                return Request.CreateResponse(HttpStatusCode.OK, "FAIL");

                //System.Console.WriteLine("Exception: {0}", ex.ToString());
            }
        }

        [HttpPost, Route("SavePrintManual")]
        [Authorize]
        public HttpResponseMessage SavePrintManual([FromBody] dynamic manualPrint)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            gSQL = "SP_NP_SNSQ088_PRINT_MANUAL_NEW";

            try
            {
                cmd.CommandText = gSQL;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);

                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = manualPrint.PART_NO == null ? (object)DBNull.Value : manualPrint.PART_NO.ToString();
                cmd.Parameters.Add("P_PART_NAME", OracleDbType.Varchar2).Value = manualPrint.PART_NAME == null ? (object)DBNull.Value : manualPrint.PART_NAME.ToString();
                cmd.Parameters.Add("P_ORIGIN_NAME", OracleDbType.Varchar2).Value = manualPrint.ORIGIN_NAME == null ? (object)DBNull.Value : manualPrint.ORIGIN_NAME.ToString();
                cmd.Parameters.Add("P_LABEL_QTY", OracleDbType.Varchar2).Value = manualPrint.LABEL_QTY;
                cmd.Parameters.Add("P_LABEL_VALUE", OracleDbType.Varchar2).Value = manualPrint.LABEL_VALUE;
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Request.CreateResponse(HttpStatusCode.OK, "DONE");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SavePrintManual");
            }

            return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
        }

        [HttpPost, Route("GetReceivingCard")]
        [ReportAuthorize]
        public HttpResponseMessage GetReceivingCard([FromBody] dynamic SRM)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            
            try
            {

                cmd.CommandText = "SP_NP_RECEIVING_CARD_RPT";
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.VENDOR_CODE == null ? (object)DBNull.Value : SRM.VENDOR_CODE;
                cmd.Parameters.Add("P_INVOICE_NO", OracleDbType.Varchar2).Value = SRM.INVOICE_NO == null ? (object)DBNull.Value : SRM.INVOICE_NO;
                cmd.Parameters.Add("P_RECEIVING_CARD_NO", OracleDbType.Varchar2).Value = SRM.RECEIVING_CARD_NO == null ? (object)DBNull.Value : SRM.RECEIVING_CARD_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetReceivingCard");
                return Request.CreateResponse(HttpStatusCode.OK, "FAIL");

                //System.Console.WriteLine("Exception: {0}", ex.ToString());
            }
        }
        [HttpPost, Route("Login")]
        public async Task<HttpResponseMessage> Login([FromBody] dynamic loginObj)
        {
            try
            {
                DataTable dt = new DataTable();
                DataTable ssdt = new DataTable();
                string gUsername = loginObj.username.ToString();
                string gPassword = loginObj.password.ToString();
                string gSystem = "01";//loginObj.company.ToString();
                DataSet ds = new DataSet();

                gSQL = "EXEC [sp_User_ByUserName] '{0}'";
                gSQL = String.Format(gSQL, gUsername);
                ssdt = odb.SqlQuery(gSQL, mDBName);

                if (ssdt.Rows[0]["RESULT"].ToString() != "DONE")
                {
                    var data = new
                    {
                        token = "Incorrect username or password.",
                        role = ""
                    };
                    return Request.CreateResponse(HttpStatusCode.NotAcceptable, data);
                }

                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SYS_User_Login";
                cmd.Parameters.Add("pUSER_ID", OracleDbType.Varchar2, gUsername, ParameterDirection.Input);
                cmd.Parameters.Add("pPASSWORD", OracleDbType.Varchar2, gPassword, ParameterDirection.Input);
                cmd.Parameters.Add("pSYSTEM_ID", OracleDbType.Varchar2, gSystem, ParameterDirection.Input);
                cmd.Parameters.Add("pRETURN_MSG", OracleDbType.Varchar2, ParameterDirection.Output);
                cmd.Parameters["pRETURN_MSG"].Size = 200;

                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string gMsg = cmd.Parameters["pRETURN_MSG"].Value.ToString();

                if (gMsg != "DONE")
                {
                    // if found error in database return
                    var data = new
                    {
                        token = gMsg,
                        role = ""
                    };
                    return Request.CreateResponse(HttpStatusCode.NotAcceptable, data);
                }

                cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SYS_User_Info";
                cmd.Parameters.Add("pUSER_ID", OracleDbType.Varchar2, gUsername, ParameterDirection.Input);
                cmd.Parameters.Add("pSYSTEM_ID", OracleDbType.Varchar2, gSystem, ParameterDirection.Input);
                cmd.Parameters.Add("cReturn", OracleDbType.RefCursor, ParameterDirection.Output);

                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];

                var Result = dt.Rows[0];

                if (ds.Tables.Count > 0)
                {
                    var claims = new List<Claim>
                    {
                    new Claim(Cons.SS_COMPANY_CODE, gSystem),
                    new Claim(Cons.SS_USER_ID, ssdt.Rows[0]["USER_ID"].ToString()),
                    new Claim(Cons.SS_USER_NAME, Result["SK_USER_ID"].ToString()),
                    new Claim(Cons.SS_USER_NAME_TH, Result["TNAME"].ToString()),
                    new Claim(Cons.SS_USER_NAME_EN, Result["ENAME"].ToString()),
                    new Claim(Cons.SS_USER_LANG, Result["LANGUAGE"].ToString()),
                    new Claim(Cons.SS_USER_DEPT, Result["SK_GRP_USER_ID"].ToString()),

                    new Claim(Cons.SS_USER_ROLE, ssdt.Rows[0]["ROLE_ID"].ToString()),
                    new Claim(Cons.SS_IP_ADDRESS, HttpContext.Current.Request.UserHostAddress.ToString())
                    };

                    var jwtToken = _tokenService.GenerateAccessTokenHandheld(claims);

                    var data = new
                    {
                        token = jwtToken,
                        role = Result["SK_GRP_USER_ID"].ToString()
                    };
                    
                    return Request.CreateResponse(HttpStatusCode.OK, data);

                }
                var data1 = new
                {
                    token = "Incorrect username or password.",
                    role = ""
                };
                return Request.CreateResponse(HttpStatusCode.NotAcceptable, data1);

            }
            catch (Exception ex)
            {
                var data1 = new
                {
                    token = "Incorrect username or password.",
                    role = ""
                };
                return Request.CreateResponse(HttpStatusCode.NotAcceptable, data1);
            }
        }


        [HttpGet, Route("GetReportViewerList")]
        [ReportAuthorize]
        public HttpResponseMessage GetReportViewerList()
        {
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandType = CommandType.StoredProcedure;
                command.CommandText = "dbo.sp_Report_Viewer_List";
                command.Parameters.Add("@ROLE_ID", SqlDbType.Int).Value = Convert.ToInt32(DataService.GetIdentity(User, Cons.SS_USER_ROLE));

                DataSet ds = odb.SqlQueryDS(command, mDBName);
                DataTable reportList = ds.Tables[0];

                return Request.CreateResponse(HttpStatusCode.OK, reportList);

            }
            catch (Exception ex)
            {
                odb.WriteLog("ErrorHandle", ex.Message, "GetReportViewerList");
                return Request.CreateResponse(HttpStatusCode.BadRequest, ex.Message);
            }
        }

        [HttpPost, Route("GetReportViewer")]
        [ReportAuthorize]
        public HttpResponseMessage GetReportViewer([FromBody] dynamic param)
        {
            try
            {
                SqlCommand command = new SqlCommand();
                command.CommandType = CommandType.StoredProcedure;
                command.CommandText = "dbo.sp_Report_Viewer_ByID";
                command.Parameters.Add("@REPORT_ID", SqlDbType.Int).Value = param.ReportID;
                command.Parameters.Add("@P_USER_ID", SqlDbType.VarChar).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                DataSet ds = odb.SqlQueryDS(command, mDBName);
                return Request.CreateResponse(HttpStatusCode.OK, ds);
            }
            catch (Exception ex)
            {
                odb.WriteLog("ErrorHandle", "Report ID: " + param.reportId + " " + ex.Message, "GetReportViewer");
                return Request.CreateResponse(HttpStatusCode.ExpectationFailed);
            }
        }
        [HttpPost, Route("RunReportViewer")]
        [ReportAuthorize]
        public IHttpActionResult RunReportViewer([FromBody] dynamic pData)
        {
            try
            {
                string query = String.Concat("SELECT Q.* FROM (", pData.query, ") Q");
                OracleCommand command = new OracleCommand();
                command.CommandType = CommandType.Text;
                command.CommandText = query;
                DataTable dataTable = oOracledb.SqlQueryText(command);
                return Ok(DTFM.convertToList(dataTable));
            }
            catch (Exception ex)
            {
                odb.WriteLog("ErrorHandle", "Report ID: " + pData.ID + " " + ex.Message, "GetReportViewer");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError));
            }
        }
        [HttpPost, Route("SaveReportViewerParams")]
        [ReportAuthorize]
        public IHttpActionResult SaveReportViewerParams([FromBody] dynamic pData)
        {
            try
            {
                var paramList = new List<dynamic>(pData.paramList);
                int count = 0;
                SqlCommand command = new SqlCommand();
                command.CommandType = CommandType.StoredProcedure;
                command.CommandText = "dbo.sp_Report_Viewer_Clear_Params";
                command.Parameters.Add("@REPORT_ID", SqlDbType.Int).Value = pData.reportId;
                odb.SqlExecute(command, mDBName);
                command = new SqlCommand();
                command.CommandType = CommandType.StoredProcedure;
                command.CommandText = "dbo.sp_Report_Viewer_Save_Name";
                command.Parameters.Add("@REPORT_ID", SqlDbType.Int).Value = pData.reportId;
                command.Parameters.Add("@REPORT_NAME", SqlDbType.NVarChar, 500).Value = pData.reportName;
                odb.SqlExecute(command, mDBName);
                foreach (var param in paramList)
                {
                    count++;
                    command = new SqlCommand();
                    command.CommandType = CommandType.StoredProcedure;
                    command.CommandText = "dbo.sp_Report_Viewer_Save_Params";
                    command.Parameters.Add("@REPORT_ID", SqlDbType.Int).Value = pData.reportId;
                    command.Parameters.Add("@PARAM_NO", SqlDbType.Int).Value = count;
                    command.Parameters.Add("@CONDITION", SqlDbType.NVarChar, 500).Value = param.CONDITION;
                    command.Parameters.Add("@REMARKS", SqlDbType.NVarChar, 500).Value = param.REMARKS;
                    command.Parameters.Add("@IS_ACTIVE", SqlDbType.NVarChar, 10).Value = param.IS_ACTIVE;
                    odb.SqlExecute(command, mDBName);
                }
                return Ok("Done");
            }
            catch (Exception ex)
            {
                odb.WriteLog("ErrorHandle", ex.Message, "SaveReportViewerParams");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError));
            }
        }
        #endregion

        #region OCPB
        [HttpPost, Route("GetOCPBPart")]
        [ReportAuthorize]
        public HttpResponseMessage GetOCPBPart([FromBody] dynamic param)
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            OracleCommand cmd = new OracleCommand();
            cmd.CommandText = "SP_NP_OCPB_GET_PART";
            cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
            cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
            cmd.Parameters.Add("P_SHOW_RECORD", OracleDbType.Int16).Value = 1000;
            cmd.Parameters.Add("C_Return", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
            ds = oOracledb.SqlQueryDS_CMD(cmd);
            dt = ds.Tables[0];
            return Request.CreateResponse(HttpStatusCode.OK, dt);
        }
        [HttpPost, Route("GenerateOCPBDataManual")]
        [Authorize]
        public HttpResponseMessage GenerateOCPBDataManual([FromBody] dynamic manualPrint)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_OCPB_GEN_DATA_MANUAL";
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = manualPrint.PART_NO == null ? (object)DBNull.Value : manualPrint.PART_NO.ToString();
                cmd.Parameters.Add("P_LABEL_QTY", OracleDbType.Varchar2).Value = manualPrint.LABEL_QTY;
                cmd.Parameters.Add("P_LABEL_VALUE", OracleDbType.Varchar2).Value = manualPrint.LABEL_VALUE;
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Request.CreateResponse(HttpStatusCode.OK, "DONE");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GenOCPBDataManual");
            }

            return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
        }

        [HttpGet, Route("GetOCPBDataManual")]
        [ReportAuthorize]
        public HttpResponseMessage GetOCPBDataManual()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_OCPB_GET_DATA_MANUAL_RPT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME); ;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetDataPrintLabelManual");
                return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
            }
        }

        [HttpPost, Route("GenOCPBReportByCriteria")]
        [ReportAuthorize]
        public HttpResponseMessage GenOCPBReportByCriteria([FromBody] dynamic SRM)
        {
            DataSet ds = new DataSet();
            OracleCommand cmd = new OracleCommand();
            try
            {
                cmd.CommandText = "SP_NP_OCPB_GEN_PO_DATA";
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.Parameters.Add("pCOMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_FROM_DATE", OracleDbType.Date).Value = SRM.DATE_FROM == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.DATE_FROM);
                cmd.Parameters.Add("P_TO_DATE", OracleDbType.Date).Value = SRM.DATE_TO == null ? (object)DBNull.Value : Convert.ToDateTime(SRM.DATE_TO);
                cmd.Parameters.Add("P_FROM_PO_NO", OracleDbType.Varchar2).Value = SRM.FROM_PO == null ? (object)DBNull.Value : SRM.FROM_PO;
                cmd.Parameters.Add("P_TO_PO_NO", OracleDbType.Varchar2).Value = SRM.TO_PO == null ? (object)DBNull.Value : SRM.TO_PO; ;
                cmd.Parameters.Add("P_PO_CLASS", OracleDbType.Varchar2).Value = SRM.PO_CLASS == null ? (object)DBNull.Value : SRM.PO_CLASS; ;
                cmd.Parameters.Add("P_FROM_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.FROM_VENDOR == null ? (object)DBNull.Value : SRM.FROM_VENDOR; ;
                cmd.Parameters.Add("P_TO_VENDOR_CODE", OracleDbType.Varchar2).Value = SRM.TO_VENDOR == null ? (object)DBNull.Value : SRM.TO_VENDOR; ;
                cmd.Parameters.Add("P_VENDOR_TYPE", OracleDbType.Varchar2).Value = SRM.VENDOR_TYPE == null ? (object)DBNull.Value : SRM.VENDOR_TYPE; ;
                cmd.Parameters.Add("P_ORDER_PART_NO", OracleDbType.Varchar2).Value = SRM.ORDER_PART_NO == null ? (object)DBNull.Value : SRM.ORDER_PART_NO; ;
                cmd.Parameters.Add("P_PRINT_STATUS", OracleDbType.Varchar2).Value = SRM.PRINT_STATUS == null ? (object)DBNull.Value : SRM.PRINT_STATUS; ;
                cmd.Parameters.Add("P_IC_INCHARGE", OracleDbType.Varchar2).Value = SRM.IC_INCHARGE == null ? (object)DBNull.Value : SRM.IC_INCHARGE; ;
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 50).Direction = ParameterDirection.Output;
                cmd = oOracledb.SqlQueryReturnValue(cmd);
                string r_status = cmd.Parameters["R_STATUS"].Value.ToString();

                return Request.CreateResponse(HttpStatusCode.OK, "DONE");
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GenReportByCriteria");
                return Request.CreateResponse(HttpStatusCode.OK, "FAIL");

                //System.Console.WriteLine("Exception: {0}", ex.ToString());
            }
        }

        [HttpGet, Route("GetOCPBDataNormal")]
        [ReportAuthorize]
        public HttpResponseMessage GetOCPBDataNormal()
        {
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_OCPB_GET_DATA_NORMAL_RPT";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_USER_ID", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME); ;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;


                ds = oOracledb.SqlQueryDS_CMD(cmd);
                dt = ds.Tables[0];
                return Request.CreateResponse(HttpStatusCode.OK, dt);
            }


            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GetOCPBDataNormal");
                return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");
            }
        }

        [HttpPost, Route("GenOCPBReportByUpload")]
        [Authorize]
        public HttpResponseMessage GenOCPBReportByUpload(ListUploadParam param)
        {
            DataSet ds = new DataSet();

            //var res = JsonConvert.DeserializeObject<dynamic>(param);

            try
            {
                int iCount = 0;
                OracleCommand cmd = new OracleCommand();
                string uploadType = string.Empty;
                foreach (var detail in param.ListData.Where(x => !string.IsNullOrEmpty(x.PART_OR_DOCUMENT)))
                {
                    iCount++;

                    uploadType = detail.PART_OR_DOCUMENT.Substring(0, 3) == "DO-" ? "DOC" : "PART";

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_OCPB_INSERT_TEMP_UPLOAD";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_OR_DOC", OracleDbType.Varchar2).Value = detail.PART_OR_DOCUMENT;
                    cmd.Parameters.Add("P_QTY", OracleDbType.Varchar2).Value = detail.QTY;
                    cmd.Parameters.Add("P_UPLOAD_TYPE", OracleDbType.Varchar2).Value = uploadType;
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }

                string spName = "SP_NP_OCPB_GEN_DATA_UPLOAD_BY_PART";
                if (uploadType == "DOC")
                    spName = "SP_NP_OCPB_GEN_DATA_UPLOAD_BY_DOC";


                cmd = new OracleCommand();
                cmd.CommandText = spName;
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);

                cmd = oOracledb.SqlExecute_CMD(cmd);

                //SP_NP_OCPB_GEN_DATA_UPLOAD_BY_PART
                return Request.CreateResponse(HttpStatusCode.OK, "DONE");

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "GenOCPBReportByUpload");
            }

            return Request.CreateResponse(HttpStatusCode.InternalServerError, "FAIL");

        }

        public class ListUploadParam
        {
            public List<UploadParam> ListData { get; set; }
        }

        public class UploadParam
        {
            public string PART_OR_DOCUMENT { get; set; }
            public string QTY { get; set; }
        }
        #endregion

        #region SNM165


        [HttpPost, Route("SNM165_Save_Upload")]
        [Authorize]
        public IHttpActionResult SNM165_Save_Upload([FromBody] dynamic[] param)
        {
            DataSet ds = new DataSet();

            try
            {
                int iCount = 0;
                OracleCommand cmd = new OracleCommand();

                foreach (var detail in param)
                {
                    iCount++;

                    cmd = new OracleCommand();
                    cmd.CommandText = "SP_NP_SNM165_INSERT_MASTER_TEMP";
                    cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = detail["PART_NO"];
                    cmd.Parameters.Add("P_PRODUCT_TYPE", OracleDbType.Varchar2).Value = detail["PRODUCT_TYPE"];
                    cmd.Parameters.Add("P_USING_PURPOSE", OracleDbType.Varchar2).Value = detail["USING_PURPOSE"];
                    cmd.Parameters.Add("P_USING_ADVICE", OracleDbType.Varchar2).Value = detail["USING_ADVICE"];
                    cmd.Parameters.Add("P_USING_WARNING", OracleDbType.Varchar2).Value = detail["USING_WARNING"];
                    cmd.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                    cmd = oOracledb.SqlQueryReturnValue(cmd);
                }
                string R_STATUS = cmd.Parameters["R_STATUS"].Value.ToString();
                string R_MESSAGE = cmd.Parameters["R_MESSAGE"].Value.ToString();

                if (R_STATUS == "FAIL")
                {
                    oOracledb.WriteLog("ErrorHandle", R_MESSAGE, "SNM165_Save_Upload");
                }

                return Json(new
                {
                    STATUS_MSG = R_STATUS,
                    R_MESSAGE
                });

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Save_Upload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }

        }

        [HttpPost, Route("SNM165_Upload")]
        [Authorize]
        public async Task<IHttpActionResult> SNM165_Upload(HttpRequestMessage request)
        {
            if (!request.Content.IsMimeMultipartContent())
            {
                throw new HttpResponseException(HttpStatusCode.UnsupportedMediaType);
            }
            var reqParts = await request.Content.ReadAsMultipartAsync();

            try
            {
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                string USER_ID = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                var file = reqParts.Contents[0];

                var buffer = await file.ReadAsByteArrayAsync();
                string gFileName = file.Headers.ContentDisposition.FileName.Trim('\"');
                string name = Path.GetFileNameWithoutExtension(gFileName);
                string ext = Path.GetExtension(gFileName);
                string gFileNameExtend = String.Concat(name, '_', USER_ID, ext);
                string gRootPath = ConfigurationManager.AppSettings["RootSharedPath"].ToString();
                string gUploadLication = System.IO.Path.Combine(gRootPath, "tempFile/SNM165");
                string gFileLocation = System.IO.Path.Combine(gUploadLication, gFileName);

                DataService.SaveBytesToFileByLocation(buffer, gUploadLication, gFileLocation);

                SystemApiController sys = new SystemApiController();
                dt = sys.ReadDataExcel(gFileLocation);
                return Json(DTFM.convertToList(dt));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Upload");
                throw new HttpResponseException(HttpStatusCode.NotAcceptable);
            }

            throw new Exception("Something wrong");

        }


        [HttpPost, Route("SNM165_GetData_Upload")]
        [Authorize]
        public IHttpActionResult SNM165_GetData_Upload([FromBody] dynamic param)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_GET_DATA_UPLOAD";
                cmd.Parameters.Add("PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN_2", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_GetData_Upload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM165_Confirm_Upload")]
        [Authorize]
        [RunBatchGuard]
        public IHttpActionResult SNM165_Confirm_Upload([FromBody] dynamic pData)
        {

            try
            {
                int iCount = 0;
                OracleCommand cmd1 = new OracleCommand();

                foreach (var detail in pData)
                {
                    iCount++;

                    cmd1 = new OracleCommand();
                    cmd1.CommandText = "SP_NP_SNM165_INSERT_MASTER_TEMP";
                    cmd1.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                    cmd1.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = detail["PART_NO"];
                    cmd1.Parameters.Add("P_PRODUCT_TYPE", OracleDbType.Varchar2).Value = detail["PRODUCT_TYPE"];
                    cmd1.Parameters.Add("P_USING_PURPOSE", OracleDbType.Varchar2).Value = detail["USING_PURPOSE"];
                    cmd1.Parameters.Add("P_USING_ADVICE", OracleDbType.Varchar2).Value = detail["USING_ADVICE"];
                    cmd1.Parameters.Add("P_USING_WARNING", OracleDbType.Varchar2).Value = detail["USING_WARNING"];
                    cmd1.Parameters.Add("P_CLEAR_DATA", OracleDbType.Varchar2).Value = iCount == 1 ? "Y" : "N";
                    cmd1.Parameters.Add("P_CREATE_BY", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd1.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd1.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;

                    cmd1 = oOracledb.SqlQueryReturnValue(cmd1);
                }
                DataSet ds = new DataSet();
                DataSet ds2 = new DataSet();
                DataTable dt = new DataTable();
                DataTable dt2 = new DataTable();
                DataSet ds3 = new DataSet();
                DataSet ds4 = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_GET_PARTS_OCPB_MASTER_TEMP";
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                string rsC = ds.Tables[0].Rows[0]["CT"].ToString();

                if (int.Parse(rsC) > 0)
                {
                    
                    //Insert supplier score master
                    OracleCommand cmd4 = new OracleCommand();
                    cmd4.CommandText = "SP_NP_SNM165_INSERT_PARTS_OCPB_MASTER ";
                    cmd4.Parameters.Add("P_USER_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                    cmd4.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd4.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                    cmd4.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                    ds4 = oOracledb.SqlQueryDS_CMD(cmd4);
                    return Json(DTFM.convertToList(ds4));
                }
                return Json(DTFM.convertToList(ds));

            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Confirm_Upload");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));

            }
        }



        [HttpPost, Route("SNM165_GetData_Master")]
        [Authorize]
        public IHttpActionResult SNM165_GetData_Master([FromBody] dynamic param)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_GET_DATA_MASTER";
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = param.PART_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_GetData_Master");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM165_Insert_PastNo")]
        [Authorize]
        public IHttpActionResult SNM165_Insert_PastNo([FromBody] dynamic pParams)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_INSERT_PART_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pParams.PART_NO;
                cmd.Parameters.Add("P_PRODUCT_TYPE", OracleDbType.Varchar2).Value = pParams.PRODUCT_TYPE;
                cmd.Parameters.Add("P_USING_PURPOSE", OracleDbType.Varchar2).Value = pParams.USING_PURPOSE;
                cmd.Parameters.Add("P_USING_ADVICE", OracleDbType.Varchar2).Value = pParams.USING_ADVICE;
                cmd.Parameters.Add("P_USING_WARNING", OracleDbType.Varchar2).Value = pParams.USING_WARNING;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Insert_PastNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM165_Check_PastNo")]
        [Authorize]
        public IHttpActionResult SNM165_Check_PastNo([FromBody] dynamic pParams)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_CHECK_PARTS_OCPB_MASTER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pParams.PART_NO;
                cmd.Parameters.Add("R_STATUS", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("R_MESSAGE", OracleDbType.Varchar2, 1000).Direction = ParameterDirection.Output;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Check_PastNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpPost, Route("SNM165_Update_PastNo")]
        [Authorize]
        public IHttpActionResult SNM165_Update_PastNo([FromBody] dynamic pParams)
        {
            try
            {
                DataSet ds = new DataSet();
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_UPDATE_PART_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pParams.PART_NO;
                cmd.Parameters.Add("P_PRODUCT_TYPE", OracleDbType.Varchar2).Value = pParams.PRODUCT_TYPE;
                cmd.Parameters.Add("P_USING_PURPOSE", OracleDbType.Varchar2).Value = pParams.USING_PURPOSE;
                cmd.Parameters.Add("P_USING_ADVICE", OracleDbType.Varchar2).Value = pParams.USING_ADVICE;
                cmd.Parameters.Add("P_USING_WARNING", OracleDbType.Varchar2).Value = pParams.USING_WARNING;
                cmd.Parameters.Add("P_SYSTEM_USER", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_USER_NAME);
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);

                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_Update_PastNo");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        [HttpPost, Route("SNM165_GetData_Part_No")]
        [Authorize]
        public IHttpActionResult SP_NP_SNM165_GET_DATA_PART_NO([FromBody] dynamic pData)
        {
            DataSet ds = new DataSet();
            try
            {
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_GET_DATA_PART_NO";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = pData.PART_NO;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNEN030_GetData");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }
        [HttpGet, Route("SNM165_GetPart/{PartNo}/{noofshowrec}")]
        [Authorize]
        public IHttpActionResult SNM165_GetPart(string PartNo, string noofshowrec)
        {
            try
            {
                DataSet ds = new DataSet();
                PartNo = ismoUtil.escapeCharacter(PartNo);
                OracleCommand cmd = new OracleCommand();
                cmd.CommandText = "SP_NP_SNM165_GET_PART_MASTER";
                cmd.Parameters.Add("P_COMPANY_CODE", OracleDbType.Varchar2).Value = DataService.GetIdentity(User, Cons.SS_COMPANY_CODE);
                cmd.Parameters.Add("P_PART_NO", OracleDbType.Varchar2).Value = PartNo.ToUpper() != "NULL" ? PartNo.ToUpper() : (object)DBNull.Value;
                cmd.Parameters.Add("C_RETURN", OracleDbType.RefCursor).Direction = ParameterDirection.Output;
                ds = oOracledb.SqlQueryDS_CMD(cmd);
                return Json(DTFM.convertToList(ds));
            }
            catch (Exception ex)
            {
                oOracledb.WriteLog("ErrorHandle", ex.Message, "SNM165_GetPart");
                return ResponseMessage(Request.CreateResponse(HttpStatusCode.InternalServerError, ex.Message));
            }
        }

        #endregion
    }
}
