﻿using System.Data;
using System.IdentityModel.Tokens.Jwt;
using SYS_Core.Services;

namespace SYS_Core.aBiz
{
    public class ReceiveTokenService
    {
        public ReceiveTokenService()
        {

        }

        public string GenerateKeyHeader(string pGUID, DataTable dtHeader)
        {
            TokenService tokenService;
            DataRow dataHeader = dtHeader.Rows[0];

            //Create header with detail
            var payload = new JwtPayload
            {
                { "I", dataHeader["INVOICE_NO"].ToString() },
                { "V", dataHeader["VENDOR_CODE"].ToString() },
                { "S", "0" },
            };

            tokenService = new TokenService();
            string token = tokenService.GenerateQRToken(pGUID, payload);

            return token;
        }

        public string GenerateKeyDetail(string pGUID, DataTable dtHeader, DataRow dataDetail)
        {
            TokenService tokenService;
            DataRow dataHeader = dtHeader.Rows[0];

            //Create header with detail
            var payload = new JwtPayload
            {
                { "I", dataHeader["INVOICE_NO"].ToString() },
                { "V", dataHeader["VENDOR_CODE"].ToString() },
                { "S", dataDetail["SEQ"].ToString() },
                { "P", dataDetail["PART_NO"].ToString() },
                { "Q", dataDetail["QTY"].ToString() }
                //,{ "L", dataDetail["LOCATION"].ToString() }
            };

            tokenService = new TokenService();
            string token = tokenService.GenerateQRToken(pGUID, payload);

            return token;
        }
    }
}
